/*
 * This file is part of qZDL
 * Copyright (C) 2007-2010  Cody Harris
 * 
 * qZDL is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
#if 0 
#include <string>

class ZDLConf;

class ZDLVariables{
public:
	/* The variable class must be aware of the conf to be able to resolve
	 * some of the more complex varible assignments.
	 */
	ZDLVariables (ZDLConf* parent);
	ZDLVariables (ZDLConf* parent, int flags);
	~ZDLVariables();
	/* Call this to get the variable.  Automatic resolving will be used. */
	QString getVariable(QString lsection, QString variable, int* status){
		const char* rc = getVariableInternal(lsection.toStdString().c_str(), variable.toStdString().c_str(), status);
		return QString(rc);
	}
	const char *getVariableInternal(const char *lsection, const char *variable, int* status);

	int hasVariable(QString lsection, QString variable, int* status){
		return 0;
	}
	int hasVariableInternal(const char *lsection, const char *variable, int* status);
	/* Set usage flags */
	void setFlags(int flags);
	/* Set the value of a variable.
	 * Set the temp flag to not write it out at close
	 */
	int setVariable(QString section, QString variable, QString value, int temp){
		return setVariableInternal(section.toStdString().c_str(), variable.toStdString().c_str(), value.toStdString().c_str(), temp);
	}
	int setVariableInternal(const char *section, const char *variable, const char *value, int temp);
private:
	int containsUnresolved(const char *inBuffer);
	char *resolveVariable(const char *inBuffer);
	int getVariableStart(const char *inBuffer);
	int getVariableEnd(const char *inBuffer);
	char *demangle(const char *inBuffer);
	int demangleHelper(const char *inBuffer);
	int _flags;
	int depth;
	ZDLConf *_parent;
	std::string blank;
	//list <ZDLVariable *>variableList;
	static int trendBytes;
	static int trendNum;
	
};

	

#endif

